<template>
  <prime-multi-select
    :model-value="modelValue"
    :options="keywords"
    option-label="value"
    :filter="true"
    class="keyword-multi-select"
    @change="$emit('update:modelValue', $event.value)"
  >
    <template #option="slotProps">
      <div class="keyword-multi-select-wrapper">
        <span>{{ slotProps.option.value }}</span>
        <keyword-group-chip
          v-for="relation in slotProps.option.relations"
          :key="relation.id"
          :keyword-group="relation.group"
        />
      </div>
    </template>
  </prime-multi-select>
</template>

<script lang="ts">
import PrimeMultiSelect from 'primevue/multiselect/MultiSelect.vue';
import { defineComponent, PropType } from 'vue';
import { getKeywordGroupColor } from '@/api/keywordGroups';
import KeywordGroupChip from '@/components/KeywordGroupChip.vue';
import { KeywordGroup } from '@/models/keywordGroup';
import { KeywordWithRelations } from '@/models/keywords';

export default defineComponent({
  name: 'keyword-multi-select',
  components: {
    PrimeMultiSelect,
    KeywordGroupChip,
  },
  props: {
    modelValue: { type: Array as PropType<KeywordWithRelations[]>, default: null },
    keywords: { type: Array as PropType<KeywordWithRelations[]>, required: true },
    groups: { type: Array as PropType<KeywordGroup[]>, required: true },
  },
  emits: ['update:modelValue'],
  computed: {
    groupsMap(): Record<number, KeywordGroup> {
      return this.groups.reduce((acc: Record<number, KeywordGroup>, item) => {
        acc[item.id] = item;
        return acc;
      }, {});
    },
    // keywordsWithGroup(): KeywordWithRelations & { groups: KeywordGroup[]} {
    //     return this.keywords.map(keyword => {
    //         const groups = keyword.relations.map(relation => this.groupsMap[relation.])
    //     });
    // },
  },
  methods: {
    getKeywordGroupColor(group: KeywordGroup) {
      return getKeywordGroupColor(group);
    },
  },
});
</script>
<style lang="scss" scoped>
.multiselect-custom {
    max-width: 500px;
}

.keyword-multi-select-wrapper {
    display: inline-flex;
    gap: 0.3rem;
    flex-wrap: wrap;
    align-items: center;
    max-width: 400px;
}
</style>

<style lang="scss">
// .p-multiselect-panel {
//         max-width: 400px;
// }
</style>
